"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from exfunc.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class PercentilesTypedDict(TypedDict):
    p10: NotRequired[float]
    p50: NotRequired[float]
    p90: NotRequired[float]


class Percentiles(BaseModel):
    p10: Optional[float] = None

    p50: Optional[float] = None

    p90: Optional[float] = None


class SalaryTypedDict(TypedDict):
    r"""Salary details for the job posting"""

    currency: NotRequired[str]
    period: NotRequired[str]
    percentiles: NotRequired[PercentilesTypedDict]


class Salary(BaseModel):
    r"""Salary details for the job posting"""

    currency: Optional[str] = None

    period: Optional[str] = None

    percentiles: Optional[Percentiles] = None


class GlassdoorJobPostingTypedDict(TypedDict):
    url: NotRequired[str]
    r"""The URL link to the Glassdoor job posting"""
    title: NotRequired[str]
    r"""The title of the job posting"""
    location: NotRequired[str]
    r"""The location of the job posting"""
    description: NotRequired[str]
    r"""Detailed description of the job posting"""
    date_posted: NotRequired[datetime]
    r"""Date when the job was posted"""
    company_name: NotRequired[str]
    r"""Name of the company offering the job"""
    company_url: NotRequired[Nullable[str]]
    r"""URL to the company page on Glassdoor"""
    company_website_url: NotRequired[Nullable[str]]
    r"""URL to the company's website"""
    salary: NotRequired[Nullable[SalaryTypedDict]]
    r"""Salary details for the job posting"""


class GlassdoorJobPosting(BaseModel):
    url: Optional[str] = None
    r"""The URL link to the Glassdoor job posting"""

    title: Optional[str] = None
    r"""The title of the job posting"""

    location: Optional[str] = None
    r"""The location of the job posting"""

    description: Optional[str] = None
    r"""Detailed description of the job posting"""

    date_posted: Optional[datetime] = None
    r"""Date when the job was posted"""

    company_name: Optional[str] = None
    r"""Name of the company offering the job"""

    company_url: OptionalNullable[str] = UNSET
    r"""URL to the company page on Glassdoor"""

    company_website_url: OptionalNullable[str] = UNSET
    r"""URL to the company's website"""

    salary: OptionalNullable[Salary] = UNSET
    r"""Salary details for the job posting"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "url",
            "title",
            "location",
            "description",
            "date_posted",
            "company_name",
            "company_url",
            "company_website_url",
            "salary",
        ]
        nullable_fields = ["company_url", "company_website_url", "salary"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
